'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = fromJSON;

var _immutable = require('immutable');

var _lodash = require('lodash');

var _uuid = require('./uuid');

var _uuid2 = _interopRequireDefault(_uuid);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function fromJSON(data, config) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  var json = (0, _lodash.isString)(data) ? JSON.parse(data) : data || {};
  if (options.type === 'rule') {
    var _json$id = json.id,
        _id = _json$id === undefined ? (0, _uuid2.default)() : _json$id,
        field = json.field,
        operator = json.operator,
        _json$options = json.options,
        _options = _json$options === undefined ? {} : _json$options,
        values = json.values,
        _json$operatorOptions = json.operatorOptions,
        operatorOptions = _json$operatorOptions === undefined ? null : _json$operatorOptions;

    var _path = (options.path || new _immutable.List()).concat(_id);
    return new _immutable.Map({
      type: 'rule',
      id: _id,
      properties: new _immutable.Map({
        field: field,
        operator: operator,
        value: new _immutable.List((0, _lodash.map)(values, 'value')),
        valueSrc: new _immutable.List((0, _lodash.map)(values, function () {
          return 'value';
        })),
        operatorOptions: operatorOptions,
        valueType: new _immutable.List((0, _lodash.map)(values, 'type')),
        options: _options
      }),
      path: _path
    });
  }

  var _json$id2 = json.id,
      id = _json$id2 === undefined ? (0, _uuid2.default)() : _json$id2,
      rules = json.rules,
      condition = json.condition,
      not = json.not;

  var path = (options.path || new _immutable.List()).concat(id);
  return new _immutable.Map({
    type: 'group',
    id: id,
    children1: function () {
      if (!(0, _lodash.isEmpty)(rules)) {
        var item = new _immutable.OrderedMap();
        (0, _lodash.each)(rules, function (rule) {
          var ruleId = (0, _lodash.get)(rule, 'id', (0, _uuid2.default)());
          item = item.set(ruleId, fromJSON(_extends({ id: ruleId }, rule), config, {
            type: (0, _lodash.isArray)(rule.rules) ? 'group' : 'rule',
            // type: 'rule',
            path: path
          }));
        });
        return item;
      }
      return undefined;
    }(),
    properties: new _immutable.Map({
      conjunction: condition,
      not: not
    }),
    path: path
  });
}